#!/usr/bin/env bash
# Copyright 2025 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

################################################################################
# Finds changed uncovered lines.
#
# Usage:
#     check/pytest-and-incremental-coverage [BASE_REVISION]
#
# You can specify a base git revision to compare against (i.e. to use when
# determining whether or not a line is considered to have "changed"). To make
# the tool more consistent, it actually diffs against the most recent common
# ancestor of the specified id and HEAD. So if you choose 'origin/main' you're
# actually diffing against the output of 'git merge-base origin/main HEAD'.
#
# If you don't specify a base revision, the following defaults will be tried,
# in order, until one exists:
#
#     1. upstream/main
#     2. origin/main
#     3. main
#
# If none exists, the script fails.
################################################################################

# Get the working directory to the repo root.
cd "$(dirname "${BASH_SOURCE[0]}")" || exit 1
cd "$(git rev-parse --show-toplevel)" || exit 1

# Figure out which revision to compare against and gather other arguments.
declare -a pytest_args=()
rev=""

for arg in "$@"; do
    if [[ "${arg}" == -* ]]; then
        pytest_args+=( "${arg}" )
    elif [[ -z "${rev}" ]] &&
        git rev-parse --verify --quiet --no-revs "${arg}^{commit}" &> /dev/null; then
        rev="${arg}"
    else
        pytest_args+=( "${arg}" )
    fi
done

if [[ -z "${rev}" ]]; then
    for candidate in upstream/main origin/main main; do
        if [[ "$(git cat-file -t "${candidate}" 2>/dev/null)" == "commit" ]]; then
            rev="${candidate}"
            break
        fi
    done
    if [[ -z "${rev}" ]]; then
        echo -e "\033[31mNo default revision found to compare against. \
Please specify a base revision (e.g. 'origin/main' or 'HEAD~1') as an argument.\033[0m" >&2
        exit 1
    fi
fi

base="$(git merge-base "${rev}" HEAD)"
if [[ "$(git rev-parse "${rev}")" == "${base}" ]]; then
    echo -e "Comparing against revision '${rev}'." >&2
else
    echo -e "Comparing against revision '${rev}' (merge base ${base})." >&2
    rev="${base}"
fi

# Run tests while producing coverage files.
check/pytest . \
    "${pytest_args[@]}" \
    --actually-quiet \
    --cov \
    --cov-report=annotate
pytest_result=$?

# Analyze coverage files.
PYTHONPATH="$(pwd)" python dev_tools/check_incremental_coverage_annotations.py "${rev}"
cover_result=$?

# Clean up generated coverage files.
find . | grep "\.py,cover$" | xargs rm -f

# Report result.
if [[ "${pytest_result}" -ne "0" ]] || [[ "${cover_result}" -ne "0" ]]; then
  exit 1
fi
exit 0
